local _, L = ...
local mediaFolder = "Interface\\AddOns\\".._.."\\Media\\"

local C_Timer_After = C_Timer.After

textPanelMixin = {}


function textPanelMixin:SetText(str, timeShow, r, g, b, a)
	if str then
		if textPanel.AnimOut:IsPlaying() then
			textPanel.AnimOut:Stop()
		end
		if textPanel.AnimIn:IsPlaying() then
			textPanel.AnimIn:Stop()
		end
		textPanelText:SetText(str)
		textPanel:SetSize(textPanelText:GetStringWidth() + 50, textPanelText:GetStringHeight() + 30)
		textPanel.border.bg:SetVertexColor(r or 0, g or 0, b or 0, a or .8)
		textPanel:Show()
		textPanel.AnimIn:Play()
		
		if timeShow then
			C_Timer_After(timeShow, function()
				textPanelText:SetText(nil)
				textPanel.AnimOut:Play()
				textPanel.AnimOut:SetScript("OnFinished", function(self)
					textPanel:Hide()
				end)
			end)
		end
	end
end

function textPanelMixin:OnEvent(event, ...)
	if ( event == "ADDON_LOADED" ) then
		local name = ...
		if name == _ then
			L.config.mythic_text_panel_unlock = false
			
			textPanel:SetSize(100, 50)
			textPanel:SetPoint("TOP", UIParent, "TOP" , 0, -60)
			textPanel:SetMovable(true)
			textPanel:SetClampedToScreen(true)
			textPanel:SetScript("OnDragStart", function(self) self:StartMoving() end)
			textPanel:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
			textPanel:RegisterForDrag("LeftButton")
	
			textPanel.border = namePlateMixin:CreateMyBackdrop(textPanel, 1, 0, 0, 0, 1, "Interface\\Buttons\\WHITE8x8", 0, 0, 0, .7, 6, 0, 0, 0, 0.4)
			textPanel.border.shadow:Show()
			textPanel:EnableMouse(false)
		
			local tPanelText = textPanel:CreateFontString("textPanelText", nil, nil)
			tPanelText:SetPoint("CENTER")
			tPanelText:SetFont(STANDARD_TEXT_FONT, 20, "OUTLINE")
			tPanelText:SetTextColor(0, 1, .5)
			tPanelText:SetJustifyH("CENTER")
			tPanelText:SetText(nil)
	
			textPanel:Hide()
		end
	end
end

function textPanelMixin:OnLoad()
	for _, event in pairs({
		"ADDON_LOADED",
	}) do self:RegisterEvent(event) end
end
